#ifndef _TIME_EVENT_HANDLER_HPP_
#define _TIME_EVENT_HANDLER_HPP_

#include "Preferences.hpp"
#include "DebugIO.hpp"

template<typename A> class TimeEventHandler
{
protected:
    TimeEventHandler()
    {
        timeout = new Timeout();
    }
    Timeout *timeout;
    PACKET packet;
    void (A::*cb)();
    int32_t interval_current;
    void read()
    {
        cb = &A::go;
    }
    void backToNOP()
    {
        cb = NULL;
    }
    virtual void checkIntervalUpdate()
    {
    }
public:
    int loop()
    {
        if(cb != NULL)
        {
            (A::self->*cb)();
        }
        A::self->checkIntervalUpdate();
        return 0;
    }
};

#endif //_TIME_EVENT_HANDLER_HPP_